define([
   "dojo/_base/declare",
   "dojo/when",
   "aps/View",
   "aps/ResourceStore",
   "./displayError"
], function (declare, when, View, Store, displayError) {
   var subscriptionId;

   return declare(View, {
      init: function() {
         /* Display explanations about the process driven by the wizard */
		return ["aps/Panel", {
			id: "wizard_panel"
		},
		[["aps/Output", {
			id: "wizard_contents",
			content: "<h2>Let's create one more server </h2>"  +
			"Before getting started, make sure you have all necessary parameters: <br>" +
			"<ul> <li> CPU power - number of CPU cores" +
			"<li> Disk space - GB" +
			"<li> RAM space - MB"
		}]]];
      },

      onContext: function(context) {
			/* Make all views plugged into the wizard visible */
			subscriptionId = context.vars.context.aps.subscription;
			aps.context.wizardState.forEach(function(view) {
					view.visible = true;
				}
			);
			aps.apsc.wizardState(aps.context.wizardState);
			aps.apsc.hideLoading();
      },

       onNext: function() {
           /* Direct a user to the first view */
           var data = { "subscriptionId": subscriptionId };
           if (aps.context.params.userId) { // If we've come here from the User Manager
               data["userId"] = aps.context.params.userId;
           }
           aps.apsc.next(data);
       },

       onSubmit: function() {
           /* Specify the subscription whose resource will be used */
           aps.context.subscriptionId = subscriptionId;

           when(aps.biz.commit(),
               function() {
                   aps.apsc.gotoView("servers");
               },
               displayError
           );
       },

       onCancel: function() {
			/* Forward a user to the list of servers */
			aps.apsc.gotoView("servers");
       }

   });
});
